RDKit: RDKit::MarvinMolBase Class Reference

| RDKit Open-source cheminformatics and machine learning.

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
RDKit::MarvinMolBase Class Referenceabstract

`#include <MarvinDefs.h>`

Inheritance diagram for RDKit::MarvinMolBase:

## Public Member Functions
virtual std::string | role () const =0
virtual bool | hasAtomBondBlocks () const =0
virtual std::string | toString () const =0
virtual ptree | toPtree () const
void | addSgroupsToPtree (ptree &pt) const
virtual MarvinMolBase * | copyMol (const std::string &idAppend) const =0
virtual void | pushOwnedAtom (MarvinAtom *atom)
virtual void | pushOwnedBond (MarvinBond *bond)
virtual void | removeOwnedAtom (MarvinAtom *atom)
virtual void | removeOwnedBond (MarvinBond *bond)
void | setPrecision (unsigned int precision)
int | getExplicitValence (const MarvinAtom &marvinAtom) const
| MarvinMolBase ()
virtual | ~MarvinMolBase ()
int | getAtomIndex (std::string id) const
int | getBondIndex (std::string id) const
const std::vector< std::string > | getBondList () const
const std::vector< std::string > | getAtomList () const
bool | AnyOverLappingAtoms (const MarvinMolBase *otherMol) const
void | cleanUpNumbering (int &molCount, int &atomCount, int &bondCount, int &sgCount, std::map< std::string, std::string > &sgMap, std::map< std::string, std::string > &atomMap, std::map< std::string, std::string > &bondMap)
virtual void | cleanUpNumberingMolsAtomsBonds (int &molCount, int &atomCount, int &bondCount, std::map< std::string, std::string > &sgMap, std::map< std::string, std::string > &atomMap, std::map< std::string, std::string > &bondMap)
void | cleanUpSgNumbering (int &sgCount, std::map< std::string, std::string > &sgMap)
virtual IsSgroupInAtomSetResult | isSgroupInSetOfAtoms (const std::vector< MarvinAtom * > &setOfAtoms) const
MarvinAtom * | findAtomByRef (std::string atomId)
MarvinBond * | findBondByRef (std::string atomId)
void | prepSgroupsForRDKit ()
void | processSgroupsFromRDKit ()
virtual bool | isPassiveRoleForExpansion () const
virtual bool | isPassiveRoleForContraction () const
virtual void | processSpecialSgroups ()
virtual void | parseMoleculeSpecific (RDKit::RWMol *mol, std::unique_ptr< SubstanceGroup > &sgroup, int sequenceId)
bool | has2dCoords () const
bool | has3dCoords () const
bool | hasAny3dCoords () const
bool | hasAny2dCoords () const
bool | hasCoords () const
void | removeCoords ()
void | parseAtomsAndBonds (ptree &molTree)

## Static Public Member Functions
static bool | atomRefInAtoms (MarvinAtom *a, std::string b)
static bool | bondRefInBonds (MarvinBond *a, std::string b)
static bool | molIDInSgroups (std::string a, std::string b)

## Public Attributes
std::string | molID
std::string | id
unsigned int | coordinatePrecision = 6
std::vector< MarvinAtom * > | atoms
std::vector< MarvinBond * > | bonds
std::vector< std::unique_ptr< MarvinMolBase > > | sgroups
MarvinMolBase * | parent

## Detailed Description

Definition at line 238 of file MarvinDefs.h.

## Constructor & Destructor Documentation

## ◆ MarvinMolBase()

RDKit::MarvinMolBase::MarvinMolBase | ( |  | ) |
| inline

Definition at line 265 of file MarvinDefs.h.

Referenced by AnyOverLappingAtoms(), RDKit::MarvinSuperatomSgroupExpanded::convertToOneSuperAtom(), RDKit::MarvinDataSgroup::copyMol(), RDKit::MarvinGenericSgroup::copyMol(), RDKit::MarvinMol::copyMol(), copyMol(), RDKit::MarvinMonomerSgroup::copyMol(), RDKit::MarvinMulticenterSgroup::copyMol(), RDKit::MarvinMultipleSgroup::copyMol(), RDKit::MarvinSruCoModSgroup::copyMol(), RDKit::MarvinSuperatomSgroup::copyMol(), RDKit::MarvinSuperatomSgroupExpanded::copyMol(), RDKit::MarvinDataSgroup::MarvinDataSgroup(), RDKit::MarvinDataSgroup::MarvinDataSgroup(), RDKit::MarvinGenericSgroup::MarvinGenericSgroup(), RDKit::MarvinGenericSgroup::MarvinGenericSgroup(), RDKit::MarvinMonomerSgroup::MarvinMonomerSgroup(), RDKit::MarvinMonomerSgroup::MarvinMonomerSgroup(), RDKit::MarvinMulticenterSgroup::MarvinMulticenterSgroup(), RDKit::MarvinMulticenterSgroup::MarvinMulticenterSgroup(), RDKit::MarvinMultipleSgroup::MarvinMultipleSgroup(), RDKit::MarvinMultipleSgroup::MarvinMultipleSgroup(), RDKit::MarvinSruCoModSgroup::MarvinSruCoModSgroup(), RDKit::MarvinSruCoModSgroup::MarvinSruCoModSgroup(), RDKit::MarvinSuperatomSgroup::MarvinSuperatomSgroup(), RDKit::MarvinSuperatomSgroup::MarvinSuperatomSgroup(), RDKit::MarvinSuperatomSgroupExpanded::MarvinSuperatomSgroupExpanded(), and RDKit::MarvinSuperatomSgroupExpanded::MarvinSuperatomSgroupExpanded().

## ◆ ~MarvinMolBase()

virtual RDKit::MarvinMolBase::~MarvinMolBase | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ addSgroupsToPtree()

void RDKit::MarvinMolBase::addSgroupsToPtree | ( | ptree & | pt | ) | const

## ◆ AnyOverLappingAtoms()

bool RDKit::MarvinMolBase::AnyOverLappingAtoms | ( | const MarvinMolBase * | otherMol | ) | const

References MarvinMolBase().

## ◆ atomRefInAtoms()

static bool RDKit::MarvinMolBase::atomRefInAtoms | ( | MarvinAtom * | a,
|  | std::string | b )
| static

## ◆ bondRefInBonds()

static bool RDKit::MarvinMolBase::bondRefInBonds | ( | MarvinBond * | a,
|  | std::string | b )
| static

## ◆ cleanUpNumbering()

void RDKit::MarvinMolBase::cleanUpNumbering | ( | int & | molCount,
|  | int & | atomCount,
|  | int & | bondCount,
|  | int & | sgCount,
|  | std::map< std::string, std::string > & | sgMap,
|  | std::map< std::string, std::string > & | atomMap,
|  | std::map< std::string, std::string > & | bondMap )

## ◆ cleanUpNumberingMolsAtomsBonds()

virtual void RDKit::MarvinMolBase::cleanUpNumberingMolsAtomsBonds | ( | int & | molCount,
|  | int & | atomCount,
|  | int & | bondCount,
|  | std::map< std::string, std::string > & | sgMap,
|  | std::map< std::string, std::string > & | atomMap,
|  | std::map< std::string, std::string > & | bondMap )
| virtual

Reimplemented in RDKit::MarvinSuperatomSgroup.

## ◆ cleanUpSgNumbering()

void RDKit::MarvinMolBase::cleanUpSgNumbering | ( | int & | sgCount,
|  | std::map< std::string, std::string > & | sgMap )

## ◆ copyMol()

virtual MarvinMolBase * RDKit::MarvinMolBase::copyMol | ( | const std::string & | idAppend | ) | const
| pure virtual

Implemented in RDKit::MarvinDataSgroup, RDKit::MarvinGenericSgroup, RDKit::MarvinMol, RDKit::MarvinMonomerSgroup, RDKit::MarvinMulticenterSgroup, RDKit::MarvinMultipleSgroup, RDKit::MarvinSruCoModSgroup, RDKit::MarvinSuperatomSgroup, and RDKit::MarvinSuperatomSgroupExpanded.

References MarvinMolBase().

## ◆ findAtomByRef()

MarvinAtom * RDKit::MarvinMolBase::findAtomByRef | ( | std::string | atomId | ) |

## ◆ findBondByRef()

MarvinBond * RDKit::MarvinMolBase::findBondByRef | ( | std::string | atomId | ) |

## ◆ getAtomIndex()

int RDKit::MarvinMolBase::getAtomIndex | ( | std::string | id | ) | const

## ◆ getAtomList()

const std::vector< std::string > RDKit::MarvinMolBase::getAtomList | ( |  | ) | const

## ◆ getBondIndex()

int RDKit::MarvinMolBase::getBondIndex | ( | std::string | id | ) | const

## ◆ getBondList()

const std::vector< std::string > RDKit::MarvinMolBase::getBondList | ( |  | ) | const

## ◆ getExplicitValence()

int RDKit::MarvinMolBase::getExplicitValence | ( | const MarvinAtom & | marvinAtom | ) | const

## ◆ has2dCoords()

bool RDKit::MarvinMolBase::has2dCoords | ( |  | ) | const

## ◆ has3dCoords()

bool RDKit::MarvinMolBase::has3dCoords | ( |  | ) | const

## ◆ hasAny2dCoords()

bool RDKit::MarvinMolBase::hasAny2dCoords | ( |  | ) | const

## ◆ hasAny3dCoords()

bool RDKit::MarvinMolBase::hasAny3dCoords | ( |  | ) | const

## ◆ hasAtomBondBlocks()

virtual bool RDKit::MarvinMolBase::hasAtomBondBlocks | ( |  | ) | const
| pure virtual

Implemented in RDKit::MarvinDataSgroup, RDKit::MarvinGenericSgroup, RDKit::MarvinMol, RDKit::MarvinMonomerSgroup, RDKit::MarvinMulticenterSgroup, RDKit::MarvinMultipleSgroup, RDKit::MarvinSruCoModSgroup, RDKit::MarvinSuperatomSgroup, and RDKit::MarvinSuperatomSgroupExpanded.

## ◆ hasCoords()

bool RDKit::MarvinMolBase::hasCoords | ( |  | ) | const

## ◆ isPassiveRoleForContraction()

virtual bool RDKit::MarvinMolBase::isPassiveRoleForContraction | ( |  | ) | const
| virtual

Reimplemented in RDKit::MarvinMol, RDKit::MarvinMultipleSgroup, and RDKit::MarvinSuperatomSgroupExpanded.

## ◆ isPassiveRoleForExpansion()

virtual bool RDKit::MarvinMolBase::isPassiveRoleForExpansion | ( |  | ) | const
| virtual

Reimplemented in RDKit::MarvinMultipleSgroup, and RDKit::MarvinSuperatomSgroup.

## ◆ isSgroupInSetOfAtoms()

virtual IsSgroupInAtomSetResult RDKit::MarvinMolBase::isSgroupInSetOfAtoms | ( | const std::vector< MarvinAtom * > & | setOfAtoms | ) | const
| virtual

Reimplemented in RDKit::MarvinSuperatomSgroup.

## ◆ molIDInSgroups()

static bool RDKit::MarvinMolBase::molIDInSgroups | ( | std::string | a,
|  | std::string | b )
| static

## ◆ parseAtomsAndBonds()

void RDKit::MarvinMolBase::parseAtomsAndBonds | ( | ptree & | molTree | ) |

## ◆ parseMoleculeSpecific()

virtual void RDKit::MarvinMolBase::parseMoleculeSpecific | ( | RDKit::RWMol * | mol,
|  | std::unique_ptr< SubstanceGroup > & | sgroup,
|  | int | sequenceId )
| virtual

Reimplemented in RDKit::MarvinDataSgroup, RDKit::MarvinGenericSgroup, RDKit::MarvinMonomerSgroup, RDKit::MarvinMulticenterSgroup, RDKit::MarvinMultipleSgroup, RDKit::MarvinSruCoModSgroup, and RDKit::MarvinSuperatomSgroupExpanded.

## ◆ prepSgroupsForRDKit()

void RDKit::MarvinMolBase::prepSgroupsForRDKit | ( |  | ) |

## ◆ processSgroupsFromRDKit()

void RDKit::MarvinMolBase::processSgroupsFromRDKit | ( |  | ) |

## ◆ processSpecialSgroups()

virtual void RDKit::MarvinMolBase::processSpecialSgroups | ( |  | ) |
| virtual

Reimplemented in RDKit::MarvinMulticenterSgroup, RDKit::MarvinMultipleSgroup, and RDKit::MarvinSuperatomSgroup.

## ◆ pushOwnedAtom()

virtual void RDKit::MarvinMolBase::pushOwnedAtom | ( | MarvinAtom * | atom | ) |
| virtual

Reimplemented in RDKit::MarvinMol.

## ◆ pushOwnedBond()

virtual void RDKit::MarvinMolBase::pushOwnedBond | ( | MarvinBond * | bond | ) |
| virtual

Reimplemented in RDKit::MarvinMol.

## ◆ removeCoords()

void RDKit::MarvinMolBase::removeCoords | ( |  | ) |

## ◆ removeOwnedAtom()

virtual void RDKit::MarvinMolBase::removeOwnedAtom | ( | MarvinAtom * | atom | ) |
| virtual

Reimplemented in RDKit::MarvinMol.

## ◆ removeOwnedBond()

virtual void RDKit::MarvinMolBase::removeOwnedBond | ( | MarvinBond * | bond | ) |
| virtual

Reimplemented in RDKit::MarvinMol.

## ◆ role()

virtual std::string RDKit::MarvinMolBase::role | ( |  | ) | const
| pure virtual

Implemented in RDKit::MarvinDataSgroup, RDKit::MarvinGenericSgroup, RDKit::MarvinMol, RDKit::MarvinMonomerSgroup, RDKit::MarvinMulticenterSgroup, RDKit::MarvinMultipleSgroup, RDKit::MarvinSruCoModSgroup, RDKit::MarvinSuperatomSgroup, and RDKit::MarvinSuperatomSgroupExpanded.

## ◆ setPrecision()

void RDKit::MarvinMolBase::setPrecision | ( | unsigned int | precision | ) |

## ◆ toPtree()

virtual ptree RDKit::MarvinMolBase::toPtree | ( |  | ) | const
| virtual

Reimplemented in RDKit::MarvinDataSgroup, RDKit::MarvinGenericSgroup, RDKit::MarvinMol, RDKit::MarvinMonomerSgroup, RDKit::MarvinMulticenterSgroup, RDKit::MarvinMultipleSgroup, RDKit::MarvinSruCoModSgroup, RDKit::MarvinSuperatomSgroup, and RDKit::MarvinSuperatomSgroupExpanded.

## ◆ toString()

virtual std::string RDKit::MarvinMolBase::toString | ( |  | ) | const
| pure virtual

Implemented in RDKit::MarvinDataSgroup, RDKit::MarvinGenericSgroup, RDKit::MarvinMol, RDKit::MarvinMonomerSgroup, RDKit::MarvinMulticenterSgroup, RDKit::MarvinMultipleSgroup, RDKit::MarvinSruCoModSgroup, RDKit::MarvinSuperatomSgroup, and RDKit::MarvinSuperatomSgroupExpanded.

## Member Data Documentation

## ◆ atoms

std::vector<MarvinAtom *> RDKit::MarvinMolBase::atoms

Definition at line 243 of file MarvinDefs.h.

## ◆ bonds

std::vector<MarvinBond *> RDKit::MarvinMolBase::bonds

Definition at line 244 of file MarvinDefs.h.

## ◆ coordinatePrecision

unsigned int RDKit::MarvinMolBase::coordinatePrecision = 6

Definition at line 242 of file MarvinDefs.h.

## ◆ id

std::string RDKit::MarvinMolBase::id

Definition at line 241 of file MarvinDefs.h.

## ◆ molID

std::string RDKit::MarvinMolBase::molID

Definition at line 240 of file MarvinDefs.h.

## ◆ parent

MarvinMolBase* RDKit::MarvinMolBase::parent

Definition at line 246 of file MarvinDefs.h.

Referenced by RDKit::MarvinDataSgroup::MarvinDataSgroup(), RDKit::MarvinDataSgroup::MarvinDataSgroup(), RDKit::MarvinGenericSgroup::MarvinGenericSgroup(), RDKit::MarvinGenericSgroup::MarvinGenericSgroup(), RDKit::MarvinMonomerSgroup::MarvinMonomerSgroup(), RDKit::MarvinMonomerSgroup::MarvinMonomerSgroup(), RDKit::MarvinMulticenterSgroup::MarvinMulticenterSgroup(), RDKit::MarvinMulticenterSgroup::MarvinMulticenterSgroup(), RDKit::MarvinMultipleSgroup::MarvinMultipleSgroup(), RDKit::MarvinMultipleSgroup::MarvinMultipleSgroup(), RDKit::MarvinSruCoModSgroup::MarvinSruCoModSgroup(), RDKit::MarvinSruCoModSgroup::MarvinSruCoModSgroup(), RDKit::MarvinSuperatomSgroup::MarvinSuperatomSgroup(), RDKit::MarvinSuperatomSgroup::MarvinSuperatomSgroup(), RDKit::MarvinSuperatomSgroupExpanded::MarvinSuperatomSgroupExpanded(), and RDKit::MarvinSuperatomSgroupExpanded::MarvinSuperatomSgroupExpanded().

## ◆ sgroups

std::vector<std::unique_ptr<MarvinMolBase> > RDKit::MarvinMolBase::sgroups

Definition at line 245 of file MarvinDefs.h.

The documentation for this class was generated from the following file:

- MarvinDefs.h